#!/usr/bin/perl
use strict;
use warnings;
use XML::Parser;
use Data::Dumper;
$Data::Dumper::Indent = 1; 

use Getopt::Long;
use Pod::Usage; 
$0 =~ m!/([^/]+)\s*$!;
my $progname = $1;
my $HOMEDIR = $ENV{HOME};
my %opt_hash;
GetOptions(\%opt_hash, 'help','d','version','nocoment','noverb','todas=s'
,'cadena') or pod2usage(2);
my $archivo = $ARGV[0];
if (not $archivo) {die "No hay argumento archivo\n"};
if( not  -f $archivo) {die "No  es archivo: $archivo\n"};
my $debug = $opt_hash{d};
$Data::Dumper::Sortkeys= 1;

my ($coderr,$ref) = clasificar_archivo($archivo);
# print __LINE__.' En simusol_clasificar ',Dumper $ref;

# ---------------------------------------------------------------------------
sub comfin{
  return unless $debug;
  print $_[0],"\n";
}
# ---------------------------------------------------------------------------
sub analizar_dia{
  # solo se preocupa de los cuadros UML - OBJECT
    comfin('com analizar_dia',@_);
  my ($dia,$ref) = @_; my $coderr = '';
  impr_simple_nodoarb(__LINE__.' analizar_dia',$dia);
#  print __LINE__.' Desd $dia ',Dumper $dia; 
# primera capa
  my $refternas= [['dia:attribute','name','text']
                 ,['dia:composite','type','text']
                 ,['dia:attribute','name','string']
	         ,['dia:string','','nombre_Simusol']];
   my @cuadros;
    my ($reflayer,$i0) = leer_nodoarb($dia,'dia:layer');
  while (defined $reflayer) {
#      print __LINE__.' Desd $reflayer ',Dumper $reflayer;
      my ($refgroup,$i0) = leer_nodoarb($reflayer,'dia:group');
      $refgroup and desagrupar($reflayer,$refgroup,$i0);
      impr_simple_nodoarb(__LINE__.' analizar_dia',$reflayer);
      (my $refobject,$i0) = leer_nodoarb($reflayer,'dia:object');
      while (defined $refobject) {
          my $nombre = $refobject->[1]->[0]->{type};
#          print __LINE__.' Desd ****************** ',$nombre," mmmmmmmmmm \n";
#          $ref->{nombre} = $nombre;
          if ($nombre eq 'UML - Object') {
              impr_simple_nodoarb(__LINE__.' an_dia',$refobject);
             my($coderr,$texto)
		  = leer_texto_cadena_name($ref,$refobject,$refternas);
              $coderr and return $coderr;
              push @cuadros, $texto;
           };
           ($refobject,$i0) = leer_nodoarb($reflayer,'dia:object');
      };
      ($reflayer,$i0) = leer_nodoarb($dia,'dia:layer');
  };
  @cuadros = union_conjunto(@cuadros);
  $ref->{cuadros} = join ' ',@cuadros;  
  comfin('fin analizar_dia',$coderr); 
  return $coderr;
}
# ---------------------------------------------------------------------------
sub analizar_shape{
  my ($shape,$ref) = @_;
  my $coderr = '';
  impr_simple_nodoarb(__LINE__.' Desd com analizar_shape',$shape);
  foreach my $tag ('name','icon') {
      $coderr = leer_tag_texto($ref,$shape,$tag);
      if ($coderr) {
          print " Problemas con etiqueta $tag\n";
          return $coderr;
      }; 
  };
#  print __LINE__.' Desd $ref',Dumper $ref;
  impr_simple_nodoarb(__LINE__.' Desd com analizar_shape',$shape);

  my ($refnodoconn,$i0) = leer_nodoarb($shape,'connections');
  if (defined $refnodoconn) {
      dejar_solo($ref,$refnodoconn,['point']);
      my ($refnodopoint,$i0) = leer_nodoarb($refnodoconn,'point');
      my $cuantospoint = 0; $ref->{main} = 0;
#      print __LINE__.' Desd $refnodopoint',Dumper $refnodopoint;
      while (defined $refnodopoint) {
#          impr_simple_nodoarb(__LINE__.' Desd com analizar_refnodoconn'
#		      ,$refnodoconn);
          $cuantospoint ++;
          defined $refnodopoint->[1]->[0]->{main}
            and $refnodopoint->[1]->[0]->{main} eq 'yes' and $ref->{main} ++;
          ($refnodopoint,$i0) = leer_nodoarb($refnodoconn,'point');
      };
      $ref->{connections} = $cuantospoint;
  };
  impr_simple_nodoarb(__LINE__.' Desd ',$shape);
  
  $ref->{'svg:svg'} or
  do {$coderr = 232;  print __LINE__.' Desd'
      , " No hay nada que dibujar\n";
  };
  defined $ref->{main} and $ref->{main} >1
  and do {$coderr = 230; print " Más de un main no tiene sentido\n";
  }; 
  defined $ref->{textbox} and $ref->{textbox} >1
  and do {$coderr = 232; print " No debe haber más de un textbox";
  };
  if ($coderr) {
      $ref->{bueno} = 'no';
  } else {
      $ref->{bueno} = 'yes';
#      $ref->{cuantosconn} = $cuantos;
      if ($ref->{name} =~ /^(\w+) \- .+$/) {
          $ref->{madresheet} = $1;
      } else  {
          $ref->{madresheet} = '';
      };
  };
  return $coderr;
}#analizar_shape
# ---------------------------------------------------------------------------
sub analizar_sheet{  
  my ($sheet,$ref)  = @_;
  my (@buenasconclase,@malasconclase,@extras);
  my $coderr = leer_tag_texto($ref,$sheet,'name');
  $coderr and return $coderr;
  $ref->{name} =~ /^Simusol\s+\-\s+(.+)$/ and $ref->{plantilla} = $1;
  my $plantilla = $1;
  my ($refcontents,$i0) = leer_nodoarb($sheet,'contents');
  impr_simple_nodoarb(__LINE__.' an_sheet',$sheet);
  impr_simple_nodoarb(__LINE__.' an_sheet',$refcontents);
  my $refshapes  = {};
  if (defined $refcontents) {
      dejar_solo($ref,$refcontents,['object']);
      my ($refobject,$i0) = leer_nodoarb($refcontents,'object');
      while (defined $refobject) {   
          dejar_solo($refshapes,$refobject,['name','description']);
          impr_simple_nodoarb(__LINE__.' an_sheet',$refobject);
          my $nombre = $refobject->[1]->[0]->{name};
          my $refsn = $refshapes->{$nombre} = {};   
          $coderr = leer_tag_texto($refsn,$refobject,'description');
          $coderr and return $coderr;
          my @clases;
          foreach my $key (keys %$refsn) {
              my $desc = $refsn->{$key};
              $desc =~ /;\s*(\w)\s*$/ and push @clases,$1;
          }; 
#          print __LINE__.' Desd @clases'," @clases\n";
          if (@clases != 0) {
              if (@clases != scalar keys %$refsn) {
                  $refsn->{bueno} = 'no';
                  push @malasconclase,$nombre;
              } else {
        	  push @buenasconclase,$nombre;
              };  
              $refsn->{clase} = join ('',union_conjunto(@clases));         
          } else {
              push @extras,$nombre;
          }; 
          ($refobject,$i0) = leer_nodoarb($refcontents,'object');
      };
  };
  @malasconclase and $ref->{bueno} = 'no' or  $ref->{bueno} = 'yes';
  $ref->{shapesbuenasconclase} = \@buenasconclase;
  $ref->{shapesmalasconclase} = \@malasconclase;
  $ref->{shapesextras} = \@extras;
  return $coderr;
}#analizar_sheet
# ---------------------------------------------------------------------------
sub analizar_texto{
  my ($archivo,$ref) = @_; 
  my @renglones = `cat $archivo`;
  my @cuantas;
  foreach my $renglon (@renglones) {
      chomp $renglon;
      $renglon =~ s/\#.+$//;
      next unless $renglon =~ /\S/;
      my @columnas = split /\s+/,$renglon; @columnas = grep /\S/,@columnas;
      my $cuantas = @columnas;
      push @cuantas, $cuantas;
  };
  @cuantas = union_conjunto( @cuantas);
  $ref->{columnas} = join ' ',@cuantas;
  print Dumper $ref;
  return;
}
# ---------------------------------------------------------------------------
sub clasificar_archivo{
  #  lo clasifica como noxml, dia, sheet, shape, otroxml
  # Es conveniente, pero no obligatorio, que los archivos diagramas tengan
  # extensión  .dia, los shapes  .shape, los sheets .sheet  
  # devuelve $coderr y para $coderr eq '', la palabra clasificatoria
  #$coderr será  distinto de '' sólo si el archivo no existe o tiene tamaño 0
  comfin('com clasificar_archivo',@_);
  my ($archivo) = @_; my $coderr = '';
  my $ref = {'ARCHIVO'=>$archivo};
  my $p = XML::Parser->new(Style=>'Tree');
  my $doc;
  eval{$doc=$p->parsefile($archivo)};
  $@ eq '' # quizas está comprimido,que es el modo natural para archivos Dia
  or do {
      my $BASEARCH = './';
      $archivo =~ /^(.*\/)[^\/]+$/  and $BASEARCH = $1;
      my $dire = '/tmp/kkk';
      -e "/tmp" or mkdir "/tmp"; 
      -e $dire or mkdir $dire; 
      -d $dire or  exit;
      $coderr = system "zcat $archivo >$dire/llll 2>/dev/null";  
      $coderr and 
      do {print " $archivo no es un buen archivo XML ni es comprimido;
                   no es un archivo de Dia\n";
      };
      if (not $coderr) {
          eval{$doc=$p->parsefile("$dire/llll")};
          $@ eq '' or 
          print " $archivo no es archivo XML ni el comprimido de un archivo XML:
                  no es un archivo para Dia\n";
      }
  };
  my $codarch;
  if ($coderr) {
      $ref->{codarch} = $codarch ='noxml';
  } else {
      impr_simple_nodoarb(__LINE__.' com clasificar_archivo',$doc);
      my $nombrenodo = $doc->[0];
      $nombrenodo eq 'dia:diagram' and $codarch ='dia' 
      or $nombrenodo eq 'sheet' and $codarch = 'sheet'
      or $nombrenodo eq 'shape' and $codarch = 'shape'
      or $nombrenodo eq 'otros' and $codarch = 'otros'
      or $codarch = 'otroxml';
      $ref->{codarch} = $codarch; my $coderr = '';
  }; 
  if ($codarch eq 'noxml') {
      analizar_texto($archivo,$ref);
  } elsif ($codarch ne 'otroxml') {
      if (not $coderr) {                 
          if ($codarch eq 'shape') {
              my @lista = qw(name icon connections textbox svg:svg);
	      impr_simple_nodoarb(__LINE__.' clas_archivo antes dejar',$doc);
              dejar_solo($ref,$doc,\@lista,['textbox','svg:svg']);
	      impr_simple_nodoarb(__LINE__.' clas_arch despues dejar ',$doc);
	      $coderr = analizar_shape($doc,$ref);
	      impr_simple_nodoarb(__LINE__.' clas_arch luego an_shape',$doc);
          } elsif ($codarch eq 'sheet') {
              dejar_solo($ref,$doc,['name','contents']);
              $coderr = analizar_sheet($doc,$ref);
          } elsif ($codarch eq 'otros') {
              dejar_solo($ref,$doc,['name','UNIDADES','contents']);
              $coderr = analizar_otr($doc,$ref);
          } else {
	      dejar_solo($ref,$doc,['dia:layer']);
              $coderr = analizar_dia($doc,$ref);
          };
      };
  };
  print __LINE__. ' Desd En clasificar_archivo ',Dumper $ref;
  comfin('fin  clasificar_archivo ',$coderr);
  return $coderr,$ref;
}
# ---------------------------------------------------------------------------
sub dejar_solo{
  # $document es referencia a lista de nodos arbolados
  # elimina todos los nodosarbolados distintos de los 
  # de @$reflista y @$reflista_solohay
  # carga $ref en relacion a los solohay
  comfin('com dejar_solo',@_); 
  my ($ref,$document,$reflista_queda,$reflista_solohay) = (@_,[],[],[]);
  my $reflista = [@$reflista_queda,@$reflista_solohay];
  $document and @$reflista or return;
#  print __LINE__.' Desd @$reflista a dejar ', "@$reflista\n";
#  print __LINE__.' Desd @$reflista_solohay a dejar ', "@$reflista_solohay\n";
  impr_simple_nodoarb(__LINE__.' com dejar_solo',$document);
#  print __LINE__.' Desd ',Dumper $document; 
  my %hash; map ($hash{$_} = 1,@$reflista);
  my %hashhay; map ($hashhay{$_}= 1,@$reflista_solohay);
#  print __LINE__.' Desd %hash ',Dumper \%hash;
  my $nombrenodo = $document->[0];
  my $reflis = $document->[1];
  my $cuantos = @$reflis; my $i= 1; 
  my %haytag;
  foreach (my $i=1; $i < $cuantos-1; $i= $i+2) {
      my $tag = $reflis->[$i];
      if (not $hash{$tag}) {
	  $reflis->[$i] = undef;
          $reflis->[$i+1] = undef;
      } elsif ($hashhay{$tag})  {
          $ref->{$tag} ++; 
      };
  };
#  print __LINE__.' Desd ',Dumper $document; 
  @$reflis = grep (defined $_,@$reflis);
  impr_simple_nodoarb(__LINE__.' fin dejar_solo',$document);
  return 
}
#---------------------------------------------------------------------------
sub hash2texto{
   #para una referencia a un hash, devuelve un renglón ..
    my $refhash =$_[0]; my $texto= '';
   if ($refhash =~/HASH/) {
       map(do {$texto .= " $_=$refhash->{$_} "},sort keys %$refhash);  
       $texto =~ s/ $//;
   };
#    print __LINE__.' Ayud',$texto,"\n";
    return $texto;
}
# ---------------------------------------------------------------------------
sub impr_simple_nodoarb{
  return unless $debug;
  my ($mensaje,$doc) = @_;
  @$doc == 0 
  and do {
      print " No hay nodo\n";
      return;
  };
  my @lista = @{$doc->[1]};
  my %hash = %{$doc->[1]->[0]};
  my $agr = '';
  scalar keys %hash > 0 and $agr = hash2texto(\%hash);
  print "impr_simple $mensaje nodoarb   $doc->[0] {$agr} "
        , scalar keys %hash,' en %hash       doble de '
        ,(scalar @lista -1)/2," en array_sin_hash \n";
}
# ---------------------------------------------------------------------------
sub leer_texto_cadena_name{
  #debe profundizar en ena cadena de requisitos y
  # si tiene exito devolver '' y el texto
  # si no devuelve error
  comfin('com leer_nodoarb_cadena_name',@_);
  my ($ref,$document,$refcadena) = @_; 
  my $coderr =''; my $texto;
  my @cadena = @$refcadena;
  my $refnodo = $document;
  foreach my $terna  (@cadena) {
      my ($tag,$name,$valor) = @$terna;
#      print __LINE__.' Desd $tag,$name,$valor ',"$tag, $name, $valor\n";
      if ($name ne ''){
          ($refnodo,my $i0) = leer_nodoarb_name($refnodo,$tag,$name,$valor); 
          impr_simple_nodoarb(__LINE__.' Desd l_t_cadena_n',$refnodo);
          if  ($refnodo) {
              next;
          } else {
             $coderr = 220; last;
          };
     } else {
         my $refs = {};
         leer_tag_texto($refs,$refnodo,$tag);
         $texto = $refs->{$tag};
     };  
  };
  impr_simple_nodoarb(__LINE__.' Desd l_t_cadena_n',$refnodo);
  comfin('fin leer_nodoarb_cadena_name',$coderr);
  return $coderr,$texto;
}
# ---------------------------------------------------------------------------
sub leer_nodoarb{
  comfin('com leer_nodoarb',@_);
  my ($document,$tag) = @_; 
  #borra el nodo de $document y devuelve referencia al nodoarb
#  print __LINE__.' Desd $tag ',"$tag\n";
  impr_simple_nodoarb(__LINE__.' com leer_nodoarb',$document);
  my $reflis = $document->[1]; my $cuantos = @$reflis;
  my ($refnodo,$i0);
#  print __LINE__.' Desd $reflis ', Dumper $reflis;
  @$reflis == 1 and return;

  foreach (my $i = 1; $i < $cuantos -1; $i = $i +2) {
      if ($reflis->[$i] eq $tag) {
          my @lista = @{$reflis->[$i+1]};
          $refnodo = [$tag,$reflis->[$i+1]]; $i0 = $i;
#           print __LINE__.'*************************************  Desd $i0 '
#          ,"$i0 $reflis->[$i0]      \n";
#          print __LINE__.' Desd $refnodoarb ',Dumper $refnodo;
#	  impr_simple_nodoarb(__LINE__.' leer_nodo arb',$refnodo);
          $reflis->[$i] = undef; $reflis->[$i+1] = undef;
          last;
      };
  };
   
  @$reflis = grep (defined $_, @$reflis);
  impr_simple_nodoarb(__LINE__.' fin leer_nodoarb',$document); 
  comfin('fin leer_nodoarb',$i0);
  return $refnodo,$i0; 
}
# ---------------------------------------------------------------------------
sub leer_nodoarb_name{
  comfin('com leer_nodoarb_name',@_);
  my ($document,$tag,$cualname,$name) = @_; my $coderr = ''; 
  my $nombre;
  my ($refnodo,$i0) = leer_nodoarb($document,$tag);
  while ($refnodo) {
      $nombre = $refnodo->[1]->[0]->{$cualname};
      defined $nombre and $nombre eq $name and last;
      ($refnodo,$i0) = leer_nodoarb_name($document,$tag,$cualname,$name);
  };
  comfin('fin leer_nodoarb_name');
  return $refnodo,$i0;
}
# ---------------------------------------------------------------------------
sub leer_tag_texto{
  comfin('com leer_tag_texto',@_);
  my ($ref,$document,$tag) = @_;
  #$document es un nodo arbolado 
  #carga el texto correspondiente al tag  en $ref->{$tag (agregado su hash)}
  #y elimina ese nodo de $document
  #devuelve $coderr, true si no existe el nodo o no tiene valor de texto

  my $coderr = '';
#  impr_simple_nodoarb(__LINE__.' com leer_tag_texto',$document);
  my $reflis = $document->[1]; my $cuantos = @$reflis;
  for (my $i = 1; $i < $cuantos; $i= $i+2) {# en 0 esta el hash
      my $palabra = $reflis->[$i]; 
      if ($palabra eq $tag) {
          my $refhash = $reflis->[$i+1]->[0];
          if ($reflis->[$i+1]->[1] eq '0') {
              my $tag1 = $tag . hash2texto($refhash);
              $ref->{$tag1} = $reflis->[$i+1]->[2];
          } else {
              $coderr = 230;  
          };
          $reflis->[$i] = undef; $reflis->[$i+1] = undef;
      }; 
  };
  @$reflis = grep (defined $_, @$reflis);
#  impr_simple_nodoarb(__LINE__.' fin leer_tag_texto',$document);
  return $coderr;
}



# ---------------------------------------------------------------------------
sub ver_shapes{
  comfin('com ver_shapes');
  my $coderr = '';
  my $dirshapes =  "$HOMEDIR/.dia/shapes";
  opendir SHAPES,$dirshapes;
  my @dirarray = readdir SHAPES; close SHAPES;
  my @dirshapes; 
  foreach my $part (@dirarray) {
      $part eq '.' or $part eq '..' and next;
      if (-d "$dirshapes/$part") {
          opendir SHAPES,"$dirshapes/$part";
          my @dirarr = readdir SHAPES; close SHAPES;
          foreach my $shape (@dirarr) {
              if ($shape =~/\.shape$/) {
                  my ($coderr,$ref)
                 = clasificar_archivo("$dirshapes/$part/$shape");
             };
          };
      } elsif ($part =~ /\.shape$/) { 
           my ($coderr,$ref) = clasificar_archivo("$dirshapes/$part");
      };
  };
  comfin('fin ver_shapes');
  return;
}
# ---------------------------------------------------------------------------
sub ver_sheets{
  comfin('com ver_sheets'); my $coderr = '';
  my $p = XML::Parser->new(Style=>'Tree');
#  my $dirsheets = $_[0];
  my $dirsheets = "$HOMEDIR/.dia/sheets";
#  $dirsheets = "/usr/share/dia/sheets";
  opendir SHEETS,$dirsheets;
  my @dirarray = readdir SHEETS; closedir SHEETS;
  @dirarray = grep (do {/\.sheet$/ and not $_ =~ /^\./ } ,@dirarray);
  my %descr_2_clase;
  foreach my $archivo (@dirarray) {
      print STDERR "$archivo\n";
      my $doc;
      eval{$doc=$p->parsefile("$dirsheets/$archivo")};
      $@ eq '' or do {
             $coderr = 246; parar1($coderr,0,
	"No es bueno el archivo $archivo para hoja de formas");
      };
      my $sheet = $$doc[1];
      my $i;
      for ($i = 0; $i < @$sheet; $i++) {
           $sheet->[$i] eq 'name' and last;
      };
      $sheet->[$i] ne 'name' and do {
         $coderr = 245; parar1($coderr,0,
	"No es bueno el archivo $archivo para hoja de formas;
                  no tienw 'name'");
      };
      $sheet->[$i+1]->[2] =~ /Simusol/ or next; #la hoja no es para Simusol
      for ($i = 0; $i < @$sheet; $i++) {
          $sheet->[$i] eq 'contents' and last;};
      $sheet->[$i] ne 'contents' and do {
         $coderr = 244; parar1($coderr,0,
	"No es bueno el archivo $archivo para hoja de formas;
              no tiene 'contents'");
      };
      my @contents = $sheet->[$i+1];
      @contents = @{$contents[0]};
      shift @contents; # ignoramos el hash
      while (@contents >2) {
          my $algo = shift @contents; $algo eq 'object' or next;
          $algo = shift @contents;
          my @shape = @$algo;
          my $refhash = shift @shape; my $nombre = $refhash->{name}; 
          not defined $nombre and do {
             $coderr = 243; parar1($coderr,0,
     	"No es bueno el archivo $archivo para hoja de formas;
             hay formas sin nombre");
          };
          my $i;
          for ($i = 0; $i < @shape; $i++) {
              $shape[$i] eq 'description' and last;
          };
          $shape[$i] ne 'description' and do {
              $coderr = 242; parar1($coderr,0,
	"No es bueno el archivo $archivo para hoja de formas;
              no tiene 'description'  en shape $nombre");
          };
          my $clase = 'nada';
          if ($shape[$i+1]->[2] =~ /;\s*(\w)\s*$/) {
              $clase = $1;
          };
          push @{$descr_2_clase{$nombre}},$clase;
#	  print STDERR "$nombre $clase";
      };
#      print STDERR "\n";
  };
  comfin('fin ver_sheets');
  return;
} #ver_sheets
# ---------------------------------------------------------------------------
sub union_conjunto{
  # Dada un lista devuelve la "misma" sin elementos repetidos (no respeta el
  # orden)
  my %hash; my @lista;
  foreach (@_) {
      next unless defined $_;
      push @lista,$_ unless defined $hash{$_};
      $hash{$_} = 1;
  };
  return @lista;
}

